From: Miguel Ojeda <ojeda@kernel.org>
To: Masahiro Yamada <masahiroy@kernel.org>,
Miguel Ojeda <ojeda@kernel.org>,
Wedson Almeida Filho <wedsonaf@gmail.com>,
Alex Gaynor <alex.gaynor@gmail.com>
Cc: "Nathan Chancellor" <nathan@kernel.org>,
"Nick Desaulniers" <ndesaulniers@google.com>,
"Nicolas Schier" <nicolas@fjasle.eu>,
"Boqun Feng" <boqun.feng@gmail.com>,
"Gary Guo" <gary@garyguo.net>,
"Björn Roy Baron" <bjorn3_gh@protonmail.com>,
"Benno Lossin" <benno.lossin@proton.me>,
"Alice Ryhl" <aliceryhl@google.com>,
"Andreas Hindborg" <nmi@metaspace.dk>,
linux-kbuild@vger.kernel.org, rust-for-linux@vger.kernel.org,
linux-kernel@vger.kernel.org, patches@lists.linux.dev,
"François Valenduc" <francoisvalenduc@gmail.com>,
"Alexandru Radovici" <msg4alex@gmail.com>,
"Matthew Leach" <dev@mattleach.net>
Subject: [PATCH v2 05/11] kbuild: rust_is_available: add check for `bindgen` invocation
Date: Fri, 16 Jun 2023 02:16:25 +0200 [thread overview]
Message-ID: <20230616001631.463536-6-ojeda@kernel.org> (raw)
In-Reply-To: <20230616001631.463536-1-ojeda@kernel.org>
`scripts/rust_is_available.sh` calls `bindgen` with a special
header in order to check whether the `libclang` version in use
is suitable.
However, the invocation itself may fail if, for instance, `bindgen`
cannot locate `libclang`. This is fine for Kconfig (since the
script will still fail and therefore disable Rust as it should),
but it is pretty confusing for users of the `rustavailable` target
given the error will be unrelated:
./scripts/rust_is_available.sh: 21: arithmetic expression: expecting primary: "100000 * + 100 * + "
make: *** [Makefile:1816: rustavailable] Error 2
Instead, run the `bindgen` invocation independently in a previous
step, saving its output and return code. If it fails, then show
the user a proper error message. Otherwise, continue as usual
with the saved output.
Since the previous patch we show a reference to the docs, and
the docs now explain how `bindgen` looks for `libclang`,
thus the error message can leverage the documentation, avoiding
duplication here (and making users aware of the setup guide in
the documentation).
Reported-by: Nick Desaulniers <ndesaulniers@google.com>
Link: https://lore.kernel.org/rust-for-linux/CAKwvOdm5JT4wbdQQYuW+RT07rCi6whGBM2iUAyg8A1CmLXG6Nw@mail.gmail.com/
Reported-by: François Valenduc <francoisvalenduc@gmail.com>
Closes: https://github.com/Rust-for-Linux/linux/issues/934
Reported-by: Alexandru Radovici <msg4alex@gmail.com>
Closes: https://github.com/Rust-for-Linux/linux/pull/921
Reported-by: Matthew Leach <dev@mattleach.net>
Closes: https://lore.kernel.org/rust-for-linux/20230507084116.1099067-1-dev@mattleach.net/
Fixes: 78521f3399ab ("scripts: add `rust_is_available.sh`")
Signed-off-by: Miguel Ojeda <ojeda@kernel.org>
---
scripts/rust_is_available.sh | 22 +++++++++++++++++++++-
1 file changed, 21 insertions(+), 1 deletion(-)
diff --git a/scripts/rust_is_available.sh b/scripts/rust_is_available.sh
index 6b8131d5b547..1bdff4472cbe 100755
--- a/scripts/rust_is_available.sh
+++ b/scripts/rust_is_available.sh
@@ -106,8 +106,28 @@ if [ "$rust_bindings_generator_cversion" -gt "$rust_bindings_generator_min_cvers
fi
# Check that the `libclang` used by the Rust bindings generator is suitable.
+#
+# In order to do that, first invoke `bindgen` to get the `libclang` version
+# found by `bindgen`. This step may already fail if, for instance, `libclang`
+# is not found, thus inform the user in such a case.
+bindgen_libclang_output=$( \
+ LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
+) || bindgen_libclang_code=$?
+if [ -n "$bindgen_libclang_code" ]; then
+ echo >&2 "***"
+ echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
+ echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
+ echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
+ echo >&2 "***"
+ echo >&2 "$bindgen_libclang_output"
+ echo >&2 "***"
+ exit 1
+fi
+
+# `bindgen` returned successfully, thus use the output to check that the version
+# of the `libclang` found by the Rust bindings generator is suitable.
bindgen_libclang_version=$( \
- LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null \
+ echo "$bindgen_libclang_output" \
| grep -F 'clang version ' \
| grep -oE '[0-9]+\.[0-9]+\.[0-9]+' \
| head -n 1 \
--
2.41.0
next prev parent reply other threads:[~2023-06-16 0:17 UTC|newest]
Thread overview: 40+ messages / expand[flat|nested] mbox.gz Atom feed top
2023-06-16 0:16 [PATCH v2 00/11] `scripts/rust_is_available.sh` improvements Miguel Ojeda
2023-06-16 0:16 ` [PATCH v2 01/11] kbuild: rust_is_available: remove -v option Miguel Ojeda
2023-06-16 13:56 ` Martin Rodriguez Reboredo
2023-06-16 0:16 ` [PATCH v2 02/11] kbuild: rust_is_available: fix version check when CC has multiple arguments Miguel Ojeda
2023-06-16 13:58 ` Martin Rodriguez Reboredo
2023-06-16 17:06 ` Nathan Chancellor
2023-06-16 0:16 ` [PATCH v2 03/11] docs: rust: add paragraph about finding a suitable `libclang` Miguel Ojeda
2023-06-16 14:00 ` Martin Rodriguez Reboredo
2023-06-16 17:07 ` Nathan Chancellor
2023-06-16 0:16 ` [PATCH v2 04/11] kbuild: rust_is_available: print docs reference Miguel Ojeda
2023-06-16 14:02 ` Martin Rodriguez Reboredo
2023-06-16 17:07 ` Nathan Chancellor
2023-06-20 5:26 ` Masahiro Yamada
2023-06-16 0:16 ` Miguel Ojeda [this message]
2023-06-16 14:06 ` [PATCH v2 05/11] kbuild: rust_is_available: add check for `bindgen` invocation Martin Rodriguez Reboredo
2023-06-16 17:11 ` Nathan Chancellor
2023-06-20 4:40 ` Masahiro Yamada
2023-06-16 0:16 ` [PATCH v2 06/11] kbuild: rust_is_available: check that environment variables are set Miguel Ojeda
2023-06-16 14:08 ` Martin Rodriguez Reboredo
2023-06-16 17:13 ` Nathan Chancellor
2023-06-20 4:59 ` Masahiro Yamada
2023-06-16 0:16 ` [PATCH v2 07/11] kbuild: rust_is_available: fix confusion when a version appears in the path Miguel Ojeda
2023-06-16 14:10 ` Martin Rodriguez Reboredo
2023-06-16 17:13 ` Nathan Chancellor
2023-06-17 15:33 ` Ethan D. Twardy
2023-06-16 0:16 ` [PATCH v2 08/11] kbuild: rust_is_available: normalize version matching Miguel Ojeda
2023-06-16 14:12 ` Martin Rodriguez Reboredo
2023-06-16 17:14 ` Nathan Chancellor
2023-06-20 5:16 ` Masahiro Yamada
2023-06-16 0:16 ` [PATCH v2 09/11] kbuild: rust_is_available: handle failures calling `$RUSTC`/`$BINDGEN` Miguel Ojeda
2023-06-16 14:14 ` Martin Rodriguez Reboredo
2023-06-16 17:15 ` Nathan Chancellor
2023-06-16 0:16 ` [PATCH v2 10/11] kbuild: rust_is_available: check that output looks as expected Miguel Ojeda
2023-06-16 14:16 ` Martin Rodriguez Reboredo
2023-06-16 17:15 ` Nathan Chancellor
2023-06-16 0:16 ` [PATCH v2 11/11] kbuild: rust_is_available: add test suite Miguel Ojeda
2023-06-16 15:00 ` Martin Rodriguez Reboredo
2023-06-16 7:45 ` [PATCH v2 00/11] `scripts/rust_is_available.sh` improvements Heghedus Razvan
2023-06-20 5:13 ` Masahiro Yamada
2023-08-09 23:20 ` Miguel Ojeda
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20230616001631.463536-6-ojeda@kernel.org \
--to=ojeda@kernel.org \
--cc=alex.gaynor@gmail.com \
--cc=aliceryhl@google.com \
--cc=benno.lossin@proton.me \
--cc=bjorn3_gh@protonmail.com \
--cc=boqun.feng@gmail.com \
--cc=dev@mattleach.net \
--cc=francoisvalenduc@gmail.com \
--cc=gary@garyguo.net \
--cc=linux-kbuild@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=masahiroy@kernel.org \
--cc=msg4alex@gmail.com \
--cc=nathan@kernel.org \
--cc=ndesaulniers@google.com \
--cc=nicolas@fjasle.eu \
--cc=nmi@metaspace.dk \
--cc=patches@lists.linux.dev \
--cc=rust-for-linux@vger.kernel.org \
--cc=wedsonaf@gmail.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.